// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

enum ControlState {
  /// When the control is disabled and un-clickable
  disabled,

  /// Default state of a control
  normal,

  /// When the mouse cursor is hover the control
  hovered,

  /// When the control is focused (like pressing tab)
  focused,

  /// When the control is selected
  selected,

  /// When the control content is invalid
  invalid;

  bool isDisabled() => this == ControlState.disabled;
  bool isEnabled() => this != ControlState.disabled;
  bool isHovered() => this == ControlState.hovered;
  bool isFocused() => this == ControlState.focused;
  bool isSelected() => this == ControlState.selected;
  bool isInvalid() => this == ControlState.invalid;
}
