// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:wyatt_ui_components/src/core/enums/control_state.dart';
import 'package:wyatt_ui_components/src/domain/entities/buttons/button_style.dart';
import 'package:wyatt_ui_components/src/domain/entities/component.dart';

abstract class ButtonComponent extends Component {
  const ButtonComponent({
    this.state = ControlState.normal,
    this.mainAxisSize = MainAxisSize.min,
    this.style,
    super.key,
  });

  /// Actual state of the button
  final ControlState? state;

  /// Main axis size
  final MainAxisSize? mainAxisSize;

  /// Style of this button
  final ButtonStyle? style;
}
